<template>
  <v-container>
    <v-row>
      <v-col cols="5">
      </v-col>
      <v-col cols="7">
        <h1>Progress Batch</h1>
      </v-col>
    </v-row>
    <v-row>
      <v-col>
        <v-data-table
            :headers="headers"
            :items="logs"
            :search="search"
            :custom-filter="doSearch"
            :single-expand="singleExpand"
            :expanded.sync="expanded"
            item-key="id"
            show-expand
        >
          <template v-slot:top>
            <v-text-field
                v-model="search"
                label="Search (UPPER CASE ONLY)"
                class="mx-4"
            ></v-text-field>
          </template>
          <template v-slot:[`item.proccess_id`] = "{ item }">
            <a v-text="item.proccess_id" @click="doOpenBatchDetail(item.proccess_id)" />
          </template>
          <template v-slot:expanded-item="{ headers, item }">
            <td :colspan="headers.length">
              <v-container>
                <v-btn
                    color="blue darken-1"
                    text
                    v-text="'reload'"
                    v-if="item.status === 'IN_PROGRESS'"
                    @click="doRefreshDetail(item.proccess_id)"
                />
                <div v-if="item.logConfigDetails">
                  <div v-for="logconfig in item.logConfigDetails" :key="logconfig.id">
                    <v-container>
                      <pre>
                      {{ logconfig.cmd }} </pre>
                      <pre>{{ logconfig.result }}</pre>
                    </v-container>
                  </div>
                </div>
              </v-container>
            </td>
          </template>
        </v-data-table>
      </v-col>
    </v-row>
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";
import service from "../service/LogConfigService";

export default {
  name: "ProgressBatch",
  components: {
    DlgMsg,
    Loading,
  },
  data:function() {
    return {
      expanded: [],
      singleExpand: true,
      search: '',
      logs: [],
      logsDetail: [],
      title: null,
      headers:[
        {text: '', value: 'data-table-expand' },
        {text: "No.", align: "center", value: "number", sortable: true},
        {text: "PROCCESS ID", align: "center", value: "proccess_id", sortable: true},
        {text: "TARGET", align: "center", value: "target", sortable: true},
        {text: "ACTION", align: "center", value: "action", sortable: true},
        {text: "STATUS", align: "center", value: "status", sortable: true},
        {text: "USERNAME", align: "center", value: "username", sortable: true},
        {text: "IP CLIENT", align: "center", value: "ip_client", sortable: true},
        {text: "START TIME", align: "center", value: "start_time", sortable: true},
        {text: "STOP TIME", align: "center", value: "stop_time", sortable: true},
      ],
      statusProgress: false,
    }
  },
  methods: {
    doSearch(value, search) {
      return value != null &&
          search != null &&
          typeof value === 'string' &&
          value.toString().toUpperCase().indexOf(search) !== -1
    },
    async doOpenBatchDetail(proccess_id) {
      this.statusProgress = false
      await this.$router.push(`/progress/batch/${proccess_id}`)
    },
    async doRefreshDetail(proccess_id) {
      this.statusProgress = true
      let username = this.$store.getters.getUsername
      await service.getByIdAndUsername(proccess_id, username).then(res => {
        if (res.data.status === 'SUCCESS') {
          let log = res.data.data
          for (let logs of this.logs) {
            if (logs.proccess_id === `${log.id}`) {
              logs.status = log.status
              logs.stop_time = log.stop_time
              logs.logConfigDetails = log.logConfigDetails
            }
          }
        }
      })
      this.statusProgress = false
    },
    async doRefresh(){
      this.statusProgress = true
      let username = this.$store.getters.getUsername
      await service.getByUsername(username)
          .then(res => {
            this.logs = res.data.data
            let number = 1
            for (let log of this.logs) {
              log.number = number++
              log.proccess_id = `${log.id}`
              let {logConfigDetails} = log
              if (logConfigDetails.length > 0) {
                logConfigDetails.sort(service.sortOrder('create_at'))
              }
            }
          })
          .catch(err => {
            console.log(err)
            console.log(err.response)
          })
      this.statusProgress = false
    },
  },
  mounted() {
    this.doRefresh()
  }
}
</script>

<style scoped>

</style>